#ifndef SoXtWebViewer_H
#define SoXtWebViewer_H

#include "GISproto.h"
#include "SoXtOLDialog.h"

#include <Inventor/Xt/viewers/SoXtWalkViewer.h>
#include <Inventor/nodes/SoCamera.h>
#include <Xm/Xm.h>
#include <Xm/SelectioB.h>

#define SLAVE 0
#define MASTER 1

void dbMsg( const char* );

class SoXtWebViewer : public SoXtWalkViewer
{
public:
  SoXtWebViewer( int status, 
		 int md,
		 Widget parent = NULL,
		 const char *name = NULL, 
		 SbBool buildInsideParent = TRUE, 
		 SoXtFullViewer::BuildFlag flag = BUILD_ALL, 
		 SoXtViewer::Type type = BROWSER );

  virtual ~SoXtWebViewer() { delete OLDlg; }
  void redraw();
  void showErrorMsg( char *title, char *message );
  void startUpdate() { update=1; }
  void stopUpdate() { update=0; }
    
protected:
  void openViewerHelpCard() { OLDlg->show(); }
  void sendCamParams();
  

private:
  static void errDialogCB( Widget w, XtPointer, XtPointer ) { XtDestroyWidget( w ); }
  static void sigio_handler( XtPointer, int*, XtInputId* );
  SoXtOLDialog* OLDlg;
  //  SbVec3f actualPos;
  //  SbRotation actualOrt;
  int master;
  int update;
  int mode;
};

#endif
